package cn.iocoder.yudao.module.system.dal.mysql.worklog;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.dal.dataobject.worklog.LogUseDO;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.ibatis.annotations.Mapper;

import java.util.Collection;
import java.util.List;

/**
 * 日志模板使用者 Mapper
 *
 * @author 艾楷
 */
@Mapper
public interface LogUseMapper extends BaseMapperX<LogUseDO> {
    /**
     * 通过数据权限获取日志模版ids
     *
     * @return
     */
    List<Long> getFormIdsByDataPermission();

    default void deleteByFormId(Long formId, Collection<Long> userIds) {

        delete(new LambdaQueryWrapper<LogUseDO>()
                .eq(LogUseDO::getFormId, formId)
                .in(LogUseDO::getUseUserId, userIds));
    }

    default Long getCountByUser(Long formId, Long userId){

        return selectCount(new LambdaQueryWrapperX<LogUseDO>()
                .eq(LogUseDO::getUseUserId, userId)
                .eq(LogUseDO::getFormId, formId));
    }

    List<Long> getDeptByFormId(Long formId);

    /**
     * 通过数据权限获取日志模版ids
     *
     * @return
     */
    List<Long> getFormIdsByDataPermission(Long userId);
}